unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, RXShell, AppEvent, Registry, StdCtrls, Grids, DCPcrypt, SHA1;



type
    TForm1 = class(TForm)
    Label1: TLabel;
    SGrid: TStringGrid;
    hash: TDCP_sha1;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
procedure CheckReestr;
function Voprosnik(txt:string):integer;
procedure SaveOtchet;
procedure LoadOtchet;
procedure EncodeFile(name:string);
procedure DecodeFile(name:string);


var
  Form1: TForm1;
  Reg:TRegistry;
  otchet:boolean;
  RegList:TStringList;
  StrBuf:PChar;
  buffer:array [0..255] of char;

implementation
uses vopros,Gost,Unit2;

{$R *.DFM}
procedure EncodeFile(name:string);
const
enc:string='1357111317';
var
f:file of char;
Encoded:string;
N1,N2:intLn;
sN1,sN2:stLn;
read:word;
Vector:string[8];
flen:word;
i:byte;
Key:XKey;
begin
assignfile(f,name);
reset(f);
flen:=Filesize(f);
GetMem(StrBuf,flen);
Blockread(f,strbuf^,flen);
closefile(f);
MakeKey(enc,Key);
Encoded:='';
read:=0;
  while read<flen do //  
      begin
       i:=0;
       Vector:='';
       while (i<8) and (read+i<flen) do
        begin
         Vector:=Vector+(StrBuf + read + I)^;
         i:=i+1;
        end;
        inc(read,i);//  .
        if i <8 then
          while i<8 do
           begin
            inc(i);
            Vector:=Vector+chr(0);
           end;
        sN1:=copy(vector,1,4);
        sN2:=copy(vector,5,8);
        N1:=ConvTextToInt(sN1);
        N2:=ConvTextToInt(sN2);
        GOSTEncrypt(N1,N2,Key);
        sN1:=ConvIntToText(N1);
        sN2:=ConvIntToText(N2);
        Encoded:=Encoded+sN1+sN2;
      end;{while }
   FreeMem( StrBuf, flen );
assignfile(f,name);
rewrite(f);
for flen:=1 to Length(Encoded) do
write(f,Encoded[flen]);
closefile(f);

end;

procedure DecodeFile(name:string);
const
enc:string='1357111317';
var
f:file of char;
decoded:string;
N1,N2:intLn;
sN1,sN2:stLn;
read:word;
Vector,s:string[8];
flen:word;
i:byte;
Key:XKey;
begin
assignfile(f,name);
reset(f);
flen:=Filesize(f);
GetMem(StrBuf,flen);
Blockread(f,strbuf^,flen);
closefile(f);
MakeKey(enc,Key);
decoded:='';
read:=0;
  while read<flen do //  
      begin
       i:=0;
       Vector:='';
       while (i<8) and (read+i<flen) do
        begin
         Vector:=Vector+(StrBuf + read + I)^;
         i:=i+1;
        end;
        inc(read,i);//  .
        if i <8 then
          while i<8 do
           begin
            inc(i);
            Vector:=Vector+chr(0);
           end;
        sN1:=copy(vector,1,4);
        sN2:=copy(vector,5,8);
        N1:=ConvTextToInt(sN1);
        N2:=ConvTextToInt(sN2);
        GOSTDecrypt(N1,N2,Key);
        sN1:=ConvIntToText(N1);
        sN2:=ConvIntToText(N2);
        decoded:=decoded+sN1+sN2;
      end;{while }
   FreeMem( StrBuf, flen );
    //,          
      s:=copy(Decoded,Length(decoded)-7,8);
      Delete(Decoded,Length(decoded)-7,8);
      // ,   
      while Pos(chr(0),S)<>0 do
      delete(s,length(s),1);

      Decoded:=Decoded+s;

assignfile(f,name);
rewrite(f);
for flen:=1 to Length(decoded) do
write(f,decoded[flen]);
closefile(f);

end;


procedure SaveOtchet;
var
i:byte;
fo:text;
begin
i:=1;
assignfile(fo,'report.txt');
rewrite(fo);
while Form1.SGrid.Cells[0,i]<>'' do
begin
writeln(fo,Form1.SGrid.Cells[0,i]);
writeln(fo,Form1.SGrid.Cells[1,i]);
writeln(fo,Form1.SGrid.Cells[2,i]);
i:=i+1;
end;
closefile(fo);
end;

procedure LoadOtchet;
var
fi:text;
s:string;
begin
assignfile(fi,'report.txt');
reset(fi);
while not(eof(fi)) do
begin
readln(fi,s);
RegList.Add(s);
end;
closefile(fi);
end;


function Voprosnik(txt:string):integer;
begin
Form2.Label2.Caption:=txt;
if Form2.ShowModal=idOk then Voprosnik:=1 else Voprosnik:=-1;
end;

procedure CheckReestr;
var
list:TStringList;
i,k:byte;
j:byte;
begin

reg:=Tregistry.Create;
List:=TStringList.Create;
Form2:=TForm2.Create(APPLICATION);
reg.RootKey:=HKEY_LOCAL_MACHINE;
reg.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run');
reg.GetValueNames(List);
k:=1;
for i:=0 to list.Count-1 do
begin
Form1.SGrid.Cells[0,k]:=List.Strings[i];
Form1.SGrid.Cells[1,k]:=reg.ReadString(List.Strings[i]);
if otchet then begin
                j:=0;
                {    -  - ,  }
                 repeat
                  if List.Strings[i]<>RegList.Strings[j] then
                   j:=j+3
                  else break;
                 until j>RegList.count-1;
                 if j>RegList.Count-1 then
                 if Voprosnik(Form1.SGrid.Cells[1,k])=1 then
                   Form1.SGrid.Cells[2,k]:=''
                   else {  }
                    begin
                     reg.DeleteKey(List.strings[i]);
                     Form1.SGrid.Cells[2,k]:='';
                     Form1.SGrid.Cells[1,k]:='';
                     Form1.SGrid.Cells[0,k]:='';
                     k:=k-1;
                    end
                  else Form1.SGrid.Cells[2,k]:=RegList.Strings[j+2];
               end{then}
          else
           begin
            {       - }
            if List.Strings[i]='Anti' then
               begin
                 Form1.SGrid.Cells[2,k]:='';
                 Form1.SGrid.Cells[1,k]:='';
                 Form1.SGrid.Cells[0,k]:='';
                 k:=k-1;
                 continue;
               end;
            if not((List.Strings[i]='LoadPowerProfile') or (List.Strings[i]='SystemTray') or (List.Strings[i]='TaskMonitor') or (List.Strings[i]='ScanRegistry'))
            then
             if Voprosnik(Form1.SGrid.Cells[1,k])=1 then
            { - }
              Form1.SGrid.Cells[2,k]:=''
            else {  }
              begin
               reg.DeleteKey(List.strings[i]);
               Form1.SGrid.Cells[2,k]:='';
               Form1.SGrid.Cells[1,k]:='';
               Form1.SGrid.Cells[0,k]:='';
               k:=k-1;
              end
           else Form1.SGrid.Cells[2,k]:='';
           end;{else}
       k:=k+1;
end;{for}

List.Clear;

reg.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunServices');
reg.GetValueNames(List);
for i:=0 to list.Count-1 do
begin
Form1.SGrid.Cells[0,k]:=List.Strings[i];
Form1.SGrid.Cells[1,k]:=reg.ReadString(List.Strings[i]);
if otchet then begin
                {    -  - ,  }
                j:=0;
                {    -  - ,  }
                 repeat
                  if List.Strings[i]<>RegList.Strings[j] then
                   j:=j+3
                  else break;
                 until j>RegList.count-1;
                 if j>RegList.Count-1 then
                 if Voprosnik(Form1.SGrid.Cells[1,k])=1 then
                   Form1.SGrid.Cells[2,k]:=''
                   else {  }
                    begin
                     reg.DeleteKey(List.strings[i]);
                     Form1.SGrid.Cells[2,k]:='';
                     Form1.SGrid.Cells[1,k]:='';
                     Form1.SGrid.Cells[0,k]:='';
                     k:=k-1;
                    end
                  else Form1.SGrid.Cells[2,k]:=RegList.Strings[j+2];
               end{then}
          else
           begin
            {       - }
            if (List.Strings[i]<>'SchedulingAgent')
            then
             if Voprosnik(Form1.SGrid.Cells[1,k])=1 then
            { - }
              Form1.SGrid.Cells[2,k]:=''
            else {  }
             begin
               reg.DeleteKey(List.strings[i]);
               Form1.SGrid.Cells[2,k]:='';
               Form1.SGrid.Cells[1,k]:='';
               Form1.SGrid.Cells[0,k]:='';
               k:=k-1;
             end
           else Form1.SGrid.Cells[2,k]:='';
           end;{else}
      k:=k+1;
end;{for}
Form2.Destroy;
list.Free;
reg.Free;
end;


{---------------------------------------}

procedure TForm1.FormCreate(Sender: TObject);
begin
Sgrid.Cells[0,0]:=' ';
Sgrid.Cells[1,0]:='  ';
Sgrid.Cells[2,0]:='';
if not(fileexists('report.txt')) then otchet:=false else otchet:=true;
RegList:=TStringList.Create;

if otchet then
begin
DecodeFile('report.txt');
LoadOtchet;
DeleteFile('report.txt');
end;
CheckReestr;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

if not(otchet) then
begin
reg:=TRegistry.Create;
reg.RootKey:=HKEY_LOCAL_MACHINE;
reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run',false);
GetSystemDirectory(buffer,SizeOf(buffer));
reg.WriteString('Anti',buffer+'\antizakladka.exe');
CopyFile('Antizakladka.exe',buffer);
reg.Free;
end;

SaveOtchet;
EncodeFile('report.txt');
if not(otchet) then CopyFile('report.txt',Buffer);
RegList.Free;

end;

end.
